#include "StdAfx.h"
#include "BuddyTreeCtrl.h"
#include "ChatDialogManager.h"
#include "SendNoteMananger.h"
#include "NeMessengerDlg.h"
#include "locale.h"
#include "main_frame.hpp"
#include "UserImageActor.h"
#include "FriendListDragHelper.h"
#include "CommonType.h"
#include "UIListCommonDefine.hpp"


///////////////////////////////////////////////////////////////////////////////////////
//////////////////////CBuddyTreeCtrl////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CBuddyTreeCtrl::~CBuddyTreeCtrl()
{
	if (m_friendDragHelper != NULL)
	{
		delete m_friendDragHelper;
		m_friendDragHelper = NULL;
	}
}

void CBuddyTreeCtrl::AddGroup(CString groupName, CString groupid, int nSortOrder, DWORD pGroup, bool bEndDown)
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	FriendListItemInfo item;

	item.id = groupid;
	item.folder = true;
	item.empty = false;
	item.nick_name = groupName;

	Node* newNode = pFriendsList->AddNodeToFavoriteList(item, nSortOrder, NULL);
	newNode->SetNodeUserData(pGroup);
	//m_pFrame->friends_.push_back(item);
	m_mapGroups.insert(make_pair(_ttoi(groupid), newNode));
	if(bEndDown)
	{
		pFriendsList->EndDown();
		pFriendsList->NeedParentUpdate();
		pFriendsList->Invalidate(TRUE);
	}
	//pFriendsList->root_node_->children_

	//newNode->set
	//pFriendsList->SortItems(GroupCompare,lr);
	//qsort_s(pFriendsList->root_node_->children_.at(0), pFriendsList->root_node_->children_.size(), sizeof(Node*), DuiLib::GroupCompare, this);	
	//pFriendsList->GetRoot()->SortChidren(GroupCompare);
}

void CBuddyTreeCtrl::DeleteGroup(int groupID)
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));

	for(int i = 0; i < pFriendsList->GetRoot()->num_children(); i++)
	{
		Node* pNode = pFriendsList->GetRoot()->child(i);

		int nID = _ttoi(pNode->data().value);
		if( nID == groupID)
		{
			map<int, Node*>::iterator it = m_mapGroups.find(groupID);
			pFriendsList->RemoveNode(pNode);
			m_mapGroups.erase(it);
			break;
		}
	}
}

void CBuddyTreeCtrl::ReplaceGroupName(int nGroupID, CString name)
{


	Node *pGroupNode = m_mapGroups[nGroupID];

	pGroupNode->data().text_ = name;


	CDuiString html_text = _T("");
	TCHAR szBuf[MAX_PATH] = {0};
	html_text += szBuf;
	html_text += pGroupNode->data().text_;

	CLabelUI* nick_name = static_cast<CLabelUI*>(m_pFrame->m_PaintManager.FindSubControlByName(pGroupNode->data().list_elment_, kNickNameControlName));
	if (nick_name != NULL)
	{
		nick_name->SetShowHtml(true);
		nick_name->SetText(html_text);
		nick_name->NeedParentUpdate();
	}
}

int __cdecl CBuddyTreeCtrl::ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2)
{
	if (!pvlocale || !elem1 || !elem2)
		return 0;
    pair<pair<std::wstring, std::wstring>,GTUserStatusType> * pr1 =(pair<pair<std::wstring, std::wstring>,GTUserStatusType>*) elem1;
	pair<pair<std::wstring, std::wstring>,GTUserStatusType> * pr2 =(pair<pair<std::wstring, std::wstring>,GTUserStatusType>*) elem2;

	std::wstring wstr1 = pr1->first.second;
	std::wstring wstr2 =  pr2->first.second;
	
	LPCTSTR cstr1 =  wstr1.c_str() ;
	LPCTSTR cstr2 =  wstr2.c_str() ;

	CString str1(cstr1);
	CString str2(cstr2);

	int Sts1 = (int)(pr1->second);
	int Sts2 = (int)(pr2->second);

	return BuddyItemComareFunc(STRUCT_BUDDY_COMPARE(str1,Sts1), STRUCT_BUDDY_COMPARE(str2,Sts2));

}

void CBuddyTreeCtrl::ResortBuddyInGroup(int nGroupID){
	CSingleLock ListLock(&m_csListAction);
	ListLock.Lock();
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	Node *pGroupNode = m_mapGroups[nGroupID];
	BuddyUserIdMap* pUserIdMap = m_pFrame->GetFavoriteView()->GetUsrIdMap();	
	pair<pair<std::wstring, int>, GTUserStatusType> pr1;	
    vector<pair<pair<std::wstring, std::wstring>, GTUserStatusType>> vecStrIDNameInGroup1;// <<strID,name>,status>
	BuddyUserIdMap::const_iterator buddyIterator = pUserIdMap->begin();

	for(; buddyIterator != pUserIdMap->end(); buddyIterator++){

		if (buddyIterator->first.second != nGroupID)
		{ 
            continue;
		} 
		pair<pair<std::wstring, std::wstring>,GTUserStatusType> userIdNamePair;
		wstring usrID = buddyIterator->first.first;
		const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(usrID.c_str());		
		userIdNamePair.first.first = buddyIterator->first.first;
		userIdNamePair.first.second = data->strName;
		
		GTUserStatusType status= g_pMessengerActor->GetBuddyInfo(usrID.c_str(),nGroupID)->GetStatus(); //GetEmployeeInfo(usrID.c_str());
		userIdNamePair.second = status;
		vecStrIDNameInGroup1.push_back(userIdNamePair);
	}
	if (vecStrIDNameInGroup1.size() < 2)
	{
		return;
	}
	qsort_s(&(vecStrIDNameInGroup1.at(0)), vecStrIDNameInGroup1.size(), sizeof(pair<pair<std::wstring, std::wstring>,GTUserStatusType>), 
		CBuddyTreeCtrl::ItemComareFunc, this);	
    ASSERT(vecStrIDNameInGroup1.size() == pGroupNode->num_children());
	int ChildCount = pGroupNode->num_children();

	vector<pair<pair<std::wstring, std::wstring>,GTUserStatusType>>::const_iterator itr = vecStrIDNameInGroup1.begin();
	wstring usrID ;
	int index = 0;
	int groupIndex = pGroupNode->data().list_elment_->GetIndex() + 1;
	for(; itr != vecStrIDNameInGroup1.end(); itr++){
      CListContainerElementUI* pListElement = NULL;
	  pair<pair<std::wstring, std::wstring>,GTUserStatusType> pr = *itr;
	  usrID = pr.first.first;
	  CDuiString strID(usrID.c_str());
	  Node* foundNode = pFriendsList->GetChildNodeByStrId(pGroupNode,strID);
	  if (foundNode)
	  {
	    pGroupNode->reinsert_child(foundNode,index);////reinsert_child()뿴cppļĺ˵
        pListElement =foundNode->data().list_elment_;
		pFriendsList->SetItemIndex(pListElement,index+groupIndex);
		index ++;
	  }
  
	}
   /*[CN]
      ֮ǰresortɾListUIؼlistElementؼõlistElement
	  DUILIBϢĲͬԣlistıѡеlistElementʵϸcontrolָѾ֮ǰĳϢбdelete
	  crash
	  ޸İ취
	  򣬱ԭlistUIlistElementlistElementindex   
   
   */
/*
	for(int i=0; i < ChildCount; i++)
	{
		Node* pNode = pGroupNode->child(0);		
	    pFriendsList->RemoveNode(pNode);		
	}
   vector<pair<pair<std::wstring, std::wstring>,GTUserStatusType>>::const_iterator itr = vecStrIDNameInGroup1.begin();
    wstring usrID ;
	for(; itr != vecStrIDNameInGroup1.end(); itr++){

		pair<pair<std::wstring, std::wstring>,GTUserStatusType> pr = *itr;
		usrID = pr.first.first;
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(usrID.c_str(), nGroupID);
		const NE_MEMBER_DATA *data = g_pMessengerActor->GetEmployeeInfo(usrID.c_str());
        AddBuddy(data, nGroupID, (DWORD)pUser);
	}*/
	ListLock.Unlock();
}

vector<Node*> CBuddyTreeCtrl::GetNodesByUserId(LPCWSTR lpUserId)
{
	vector<Node*> vecNodes;
	if(lpUserId == NULL || m_mapGroups.size() == 0)
	{
		return vecNodes;
	}

	for(std::map<int, Node*>::iterator it = m_mapGroups.begin();
		it != m_mapGroups.end(); it++)
	{
		Node* pNodeGroup = it->second;
		if(pNodeGroup == NULL) break;

		for(int i = 0; i < pNodeGroup->num_children(); i++)
		{
			Node* pNode = pNodeGroup->child(i);
			if(pNode == NULL) break;

			CDuiString nID = pNode->data().value;

			if( nID == lpUserId)    //lint !e58
			{
				if(vecNodes.end() == std::find(vecNodes.begin(), vecNodes.end(), pNode))
				{
					vecNodes.push_back(pNode);
					continue;
				}
			}
		}
	}

	return vecNodes;

}

void CBuddyTreeCtrl::DeleteBuddy(CString strUserId, int nGroupID)
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));

	//Fix Me
	//this line may be crush.
	Node *pGroupNode = m_mapGroups[nGroupID];

	BuddyUserIdMap* pUserIdMap = m_pFrame->GetFavoriteView()->GetUsrIdMap();

	bool bRet=true;

	std::pair<std::wstring, int> pair1 = make_pair(wstring(strUserId), nGroupID);
	BuddyUserIdMap::const_iterator buddyIterator = pUserIdMap->find( pair1 );

	if (buddyIterator == pUserIdMap->end())
	{
		bRet = false;
	}
	if (bRet == true)
	{  
		pUserIdMap->erase(buddyIterator);
	}


	for(int i = 0; i < pGroupNode->num_children(); i++)
	{
		Node* pNode = pGroupNode->child(i);

		CDuiString nID = pNode->data().value;

		if( nID == strUserId.GetBuffer())
		{
			pFriendsList->RemoveNode(pNode);
			break;
		}
	}
}

static int _stdcall GroupCompare(UINT_PTR item1, UINT_PTR item2, UINT_PTR data)
{
	Node *pControl1 = (Node *)item1;
	Node *pControl2 = (Node *)item2;

	int n1 = pControl1->GetCompareData();
	int n2 = pControl2->GetCompareData();

	return n1 < n2 ? -1:1;
}


void CBuddyTreeCtrl::AddBuddy(const NE_MEMBER_DATA *pUserData, int nGroupid, DWORD pUser)
{
	//return;

	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));

	FriendListItemInfo item;

	IGTBuddyUser* pp= (IGTBuddyUser*)pUser; 

	item.folder = false;
	item.logo = GET_APP()->GetProfileImagePath(pUserData->strUserId.c_str());
// 	OutputDebugString(L"(99999999999999999999999");
// 	OutputDebugString(item.logo.GetData());
// 	OutputDebugStringA("\n");

	item.nick_name = pUserData->strName.c_str();
	item.id = pUserData->strUserId.c_str();
	item.sign = pUserData->strNickName.c_str();

	GTUserStatusType ust = pp->GetStatus();
	item.mobile = ( ust & ustMOBILE );
	item.description =  m_pFrame->GetImageFromStatus( ust, TRUE,!pUserData->strWorkStatus.empty());

	NTIPTStatusType iptStatus = pp->GetIPTStatus();
	item.IPTStatus = GET_APP()->GetBuddyIPTPresenceImageFilePath(iptStatus);

	Node *pGroupNode = m_mapGroups[nGroupid];

	Node *pUserNode = pFriendsList->AddNodeToFavoriteList(item, nGroupid, pGroupNode);
	//pUserNode->SetNodeUserData(pUser);

    //SetNodeUserData() only used in group-type node. For buddy node, it should NOT setnodeuserdata() and getNodeUserData(); --jializhen
    BuddyUserIdMap* pUserIdMap = m_pFrame->GetFavoriteView()->GetUsrIdMap();

	bool bRet=true;

	BuddyUserIdMap::const_iterator buddyIterator = 
		pUserIdMap->find(make_pair(pp->GetUserID(), nGroupid));

	if (buddyIterator == pUserIdMap->end())
	{
		bRet = false;
	}
	if (bRet == false)
	{  
		pUserIdMap->insert(make_pair(make_pair(pp->GetUserID(), nGroupid), pUserNode));
	}
}

void CBuddyTreeCtrl::Invalidate()
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	pFriendsList->Invalidate();
}

void CBuddyTreeCtrl::UpdataAllBuddyImage()
{
	/*if (!m_pFrame->m_vecRequestImageID.empty() && !m_pFrame->m_bUpdateImage)
	{
		m_pFrame->RequestUserImage(m_pFrame->m_vecRequestImageID[0]);
	}*/
}

std::vector<Node*> CBuddyTreeCtrl::GetAllItems()
{
    CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
    std::list<Node*> listSelectedItems;
    listSelectedItems = pFriendsList->GetAllItems();
    std::vector<Node*> vecSelectedItems;
    for(std::list<Node*>::iterator it = listSelectedItems.begin(); 
        it != listSelectedItems.end(); it++)
    {
        vecSelectedItems.push_back(*it);
    }
    return vecSelectedItems;
}

std::vector<Node*> CBuddyTreeCtrl::GetSelectedItems()
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	std::list<Node*> listSelectedItems;
	listSelectedItems = pFriendsList->GetSelectedItems();
	std::vector<Node*> vecSelectedItems;
	for(std::list<Node*>::iterator it = listSelectedItems.begin(); 
		it != listSelectedItems.end(); it++)
	{
		vecSelectedItems.push_back(*it);
	}
	return vecSelectedItems;
}

CWnd* CBuddyTreeCtrl::GetParent()
{
	return CWnd::FromHandle(m_pFrame->GetSafeHwnd());
}

void CBuddyTreeCtrl::OnRButtonEvent( bool bDown, int nIndex )
{
	if(bDown)
	{
		//CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
		//pFriendsList->SelectItem(nIndex);
	}
	else
	{
		//if dragging do nothing
		CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
		CControlUI* pControlUI = pFriendsList->GetItemAt(nIndex);
		if(pControlUI != NULL)
		{
			Node* pNode = (Node*)pControlUI->GetTag();
			if(pNode != NULL)
				MakeContextMenu(pNode);
		}
		else
		{
			MakeContextMenu(NULL);
		}
	}
}

void CBuddyTreeCtrl::MakeContextMenu(Node* pNode)
{
	//UINT uFlags;

	CMenu standardmenu;
	CMenu* pPopup = NULL;
	standardmenu.LoadMenu(IDR_MEMU_COMMON_MENU);	
    //CMenuXP* pXpMenu CMenuXP::ConvertFromStandardMenu(standardmenu, XpMenuFacadeInit);

	bool bShowUserMenu = false;
	if( pNode == NULL )
	{
		pPopup = CreateUnSelectedMenu(pPopup, standardmenu); //*pXpMenu);
	}
	else
	{
		pPopup = CreateSelectedMenu(pNode, pPopup, standardmenu, bShowUserMenu); //*pXpMenu
	}

	int nDeletedMenuCount = 0;
	if( pPopup != NULL )
	{
		if (pNode && bShowUserMenu)
		{
			bool bGroup = pNode->folder();
			if(!bGroup)
			{
				if (!GET_CONFIG()->EnableFunction(_T("ME_04")))
				{
					pPopup->DeleteMenu(5, MF_BYPOSITION);
					nDeletedMenuCount++;
				}
				else if( GET_APP()->IsAvailableIPT() != TRUE )
				{
					pPopup->DeleteMenu(5, MF_BYPOSITION);
					nDeletedMenuCount++;
				}
				else
				{
					NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
					//const IGTBuddyUser* pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
					CString usrID = pNode->data().value;
					const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
					if (NULL != pUser)
					{
						NTIPTStatusType iptStatusOfBuddy = pUser->GetIPTStatus();

						const NE_MEMBER_DATA* pMembereData = g_pMessengerActor->GetEmployeeInfo(pUser->GetUserID()); 

						MakeIPTMenu(iptMyStatus, iptStatusOfBuddy, pMembereData, pPopup);
					}
				}
			}

			bool bShowBuddyActions = true;
			
			vector<Node*> vecSelectItems = GetSelectedItems();
			for(int i = 0; i < (int)vecSelectItems.size(); i++)
			{
				Node* pNodeParent = vecSelectItems[i]->parent();
				if(IsGroup(pNodeParent))
				{
					IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNodeParent->GetNodeUserData();
					if(pGroup && pGroup->GetID() == RECENT_CONTACT_GROUP_ID)
					{
						bShowBuddyActions = false;
						break;
					}
				}

				/*if(IsGroup(vecSelectItems[i]->parent()))
				{
					IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
					if(pGroup && pGroup->GetID() == RECENT_CONTACT_GROUP_ID)
					{
						bShowBuddyActions = false;
						break;
					}
				}*/
			}

            if(!bShowBuddyActions)
			{
				pPopup->EnableMenuItem(8 - nDeletedMenuCount, MF_BYPOSITION | MF_GRAYED | MF_DISABLED);
				pPopup->EnableMenuItem(9 - nDeletedMenuCount, MF_BYPOSITION | MF_GRAYED | MF_DISABLED);
			}
		}

		POINT point = {0};
		::GetCursorPos(&point);
		int nCmdID = pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, point.x, point.y, CWnd::FromHandle(m_pFrame->GetSafeHwnd()));

		MenuCmd(nCmdID, pNode);
	}

	standardmenu.DestroyMenu();
    //SAFE_DELETE(pXpMenu);
}

bool CBuddyTreeCtrl::IsGroup( int nIndex ) 
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	CControlUI* pControl = pFriendsList->GetItemAt(nIndex);
	Node* node = NULL;
	if( pControl != NULL) 
	{
		node = (Node*)pControl->GetTag();
        if (node)
        {
            return (node->folder() && !node->IsRoot());
        }
	}
    ASSERT(FALSE); //if come here, then the old code will crash
    return false;   //lint !e527
}

bool CBuddyTreeCtrl::IsGroup( Node* pNode ) 
{
	return (pNode->folder() && !pNode->IsRoot());
}

bool CBuddyTreeCtrl::IsSelectedItemsSingleType()
{
	bool bRet = false;
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	list<Node*> listItems = pFriendsList->GetSelectedItems();
	for(list<Node*>::iterator it = listItems.begin(); it != listItems.end(); it++)
	{
		Node* pNode = *it;
		if(!pNode->folder())
		{
			bRet =true;
		}
	}

	return bRet;

}


CMenu* CBuddyTreeCtrl::CreateUnSelectedMenu( CMenu* pPopup, CMenu &menu )
{
	pPopup = menu.GetSubMenu(5);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_MEMO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_MAKE, MF_BYCOMMAND | (!g_bFavoriteListDlgOpened ? MF_ENABLED : MF_DISABLED));
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_RENAME, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_DEL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_SENDFILE,  MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	pPopup->EnableMenuItem(ID_FAVORITE_GROUP_EMAIL,  MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

	return pPopup;
}

CMenu* CBuddyTreeCtrl::CreateSelectedMenu( Node* pNode, CMenu* pPopup, CMenu& menu, bool& bShowUserMenu )
{
	
	if (pNode->folder() && false == IsSelectedItemsSingleType())
	{
		pPopup = CreateGroupMenu(pNode, pPopup, menu);

	}
	else
	{
		pPopup = CreateUserMenu(pPopup, menu, pNode);
		bShowUserMenu = true;
	}

	return pPopup;
}

CMenu* CBuddyTreeCtrl::CreateGroupMenu( Node* pNode, CMenu* pPopup, CMenu &menu )
{
	const IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
	if (NULL!= pGroup)
	{
		int onlineCount = 0;
		int buddyCount = 0;

		pPopup = menu.GetSubMenu(9);

		bool bShowBuddyActions = true;
		bool bSingleGroupSelected = true;
		vector<Node*> vecSelectedItems = GetSelectedItems();
		if (vecSelectedItems.size() > 1)
		{
			bSingleGroupSelected = false;
		}
		for(int i = 0; i < (int)vecSelectedItems.size(); i++)
		{
			if(vecSelectedItems[i]->folder())
			{
				IGTBuddyGroup* pInnerGroup = (IGTBuddyGroup*)vecSelectedItems[i]->GetNodeUserData();
				if(pInnerGroup && pInnerGroup->GetID() == RECENT_CONTACT_GROUP_ID)
				{
					bShowBuddyActions = false;
					break;
				}
			}
		}

		if(!bShowBuddyActions)
		{
			onlineCount = m_favoriteController->GetRecentContactGroupOnlineBuddyCount();
			buddyCount = m_favoriteController->GetRecentContactGroupBuddyCount();
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_RENAME, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_DEL,  MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			
		}
		else
		{
			onlineCount = m_favoriteController->GetGroupOnlineBuddyCount(pGroup);
			buddyCount = m_favoriteController->GetGroupBuddyCount(pGroup);
		}

		if (!bSingleGroupSelected)
		{
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_MAKE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_RENAME, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_DEL,  MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}

		if(onlineCount == 0)
		{
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_SENDFILE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

		}

		if (buddyCount == 0)
		{
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_EMAIL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_MEMO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}
		else
		{
#ifdef _DEBUG
#else
			if(GET_CONFIG()->EnableFunction(_T("ME_01")) == FALSE)
				pPopup->EnableMenuItem(ID_FAVORITE_GROUP_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
#endif
		}

		if (g_bFavoriteListDlgOpened)
		{
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_MAKE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_RENAME, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_DEL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}
		if (false == IsSingleSelectedGroup())
		{
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_MAKE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_RENAME, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			pPopup->EnableMenuItem(ID_FAVORITE_GROUP_DEL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}
	}

	return pPopup;
}

void CBuddyTreeCtrl::SetController( FavoriteController* favoriteController )
{
	m_favoriteController = favoriteController;
}

bool CBuddyTreeCtrl::IsSingleSelectedGroup()
{
	bool bRet=true;
	int nCount = 0;

	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	list<Node*> listItems = pFriendsList->GetSelectedItems();
	for(list<Node*>::iterator it = listItems.begin(); it != listItems.end(); it++)
	{
		Node* node = *it;
		if(!node->folder())
		{
			nCount++;
		}
	}

	if (nCount > 1)
		bRet=false;

	return bRet;
}

void CBuddyTreeCtrl::MakeMoveGroupMenu( CMenu* pPopup, std::vector<const IGTBuddyUser *> selectedBuddys) 
{
	if (NULL == pPopup)
		return;

	CMenu* pCopyGroupItem = pPopup->GetSubMenu(7);
	CMenu* pMoveGroupItem = pPopup->GetSubMenu(8);

	int i;
	for(i = pCopyGroupItem->GetMenuItemCount() - 1; i > -1; i--)
		pCopyGroupItem->DeleteMenu(i, MF_BYPOSITION);
	for(i = pMoveGroupItem->GetMenuItemCount() - 1; i > -1; i--)
		pMoveGroupItem->DeleteMenu(i, MF_BYPOSITION);

	i = 0;
	std::vector<std::wstring> groupList;
	groupList = m_favoriteController->GetTargetGroupNameList(0);
	for(std::vector<std::wstring>::iterator groupIterator = groupList.begin(); groupIterator != groupList.end(); ++groupIterator)
	{			
		pCopyGroupItem->AppendMenu(MF_STRING, ID_COPYGROUPLIST_START + i, groupIterator->c_str());
		pMoveGroupItem->AppendMenu(MF_STRING, ID_MOVEGROUPLIST_START + i, groupIterator->c_str());			
		i++;
	}
}

CMenu* CBuddyTreeCtrl::CreateUserMenu( CMenu* pPopup, CMenu &menu, Node* pNode )
{
	std::vector<const IGTBuddyUser *> selectedBuddyItems;
	m_favoriteController->GetSelectedBuddyItems(selectedBuddyItems);

	const int onlineCount = m_favoriteController->GetSelectedOnlineFavoritesCount();
	pPopup = menu.GetSubMenu(10);

	if(onlineCount == 0)
	{
		pPopup->EnableMenuItem(ID_FAVORITE_USER_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(ID_FAVORITE_USER_SENDFILE,MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if(selectedBuddyItems.size() > 1)
	{

		pPopup->EnableMenuItem(ID_FAVORITE_USER_EXTENTION_TEL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(ID_FAVORITE_USER_COMPANY_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(ID_FAVORITE_USER_CELL_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(ID_FAVORITE_USER_CHAT_HISTORY, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	MakeMoveGroupMenu(pPopup,  selectedBuddyItems);

#ifdef _DEBUG

#else
	if(GET_CONFIG()->EnableFunction(_T("ME_01")) == FALSE)
		pPopup->EnableMenuItem(ID_FAVORITE_USER_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
#endif

	/*if(GET_CONFIG()->EnableFunction(_T("UI_03")) == FALSE)
		pPopup->EnableMenuItem(ID_FAVORITE_USER_INFO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);*/

	return pPopup;
}

void CBuddyTreeCtrl::MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup ) 
{
	pPopup->InsertMenu(ID_FAVORITE_USER_CONFER_CALL, MF_BYCOMMAND, MF_SEPARATOR );
	if( !(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || pMembereData->strExtesion.empty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->EnableMenuItem(ID_FAVORITE_USER_EXTENTION_TEL, MF_GRAYED | MF_DISABLED);

	}

	if( !(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE ||pMembereData->strIncoTel.empty() || !GET_CONFIG()->EnableFunction(_T("SR_05")))
	{
		pPopup->EnableMenuItem(ID_FAVORITE_USER_COMPANY_PHONE, MF_GRAYED | MF_DISABLED);
	}
	if( !(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || pMembereData->strCellPhone.empty() || !GET_CONFIG()->EnableFunction(_T("SR_07")) )
	{
		pPopup->EnableMenuItem(ID_FAVORITE_USER_CELL_PHONE, MF_GRAYED | MF_DISABLED);
	}
	if(iptMyStatus != iptstACTIVE || pMembereData->strExtesion.empty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->EnableMenuItem(ID_FAVORITE_USER_CONFER_CALL, MF_GRAYED | MF_DISABLED);
		pPopup->EnableMenuItem(ID_FAVORITE_USER_TRANSFER_CALL, MF_GRAYED | MF_DISABLED);

	}

	if (!GET_CONFIG()->EnableFunction(_T("SR_05")))
	{
		pPopup->DeleteMenu(ID_FAVORITE_USER_COMPANY_PHONE, MF_BYCOMMAND);
	}

	if ( !GET_CONFIG()->EnableFunction(_T("SR_07")))
	{
		pPopup->DeleteMenu(ID_FAVORITE_USER_CELL_PHONE, MF_BYCOMMAND);
	}
	if (!GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->DeleteMenu(ID_FAVORITE_USER_CONFER_CALL, MF_BYCOMMAND);
		pPopup->DeleteMenu(ID_FAVORITE_USER_TRANSFER_CALL, MF_BYCOMMAND);
		pPopup->DeleteMenu(ID_FAVORITE_USER_EXTENTION_TEL, MF_BYCOMMAND);
	}
}

void CBuddyTreeCtrl::MakeProfileDlg() 
{
	std::vector<const IGTBuddyUser *> selectedBuddys;
	m_favoriteController->GetSelectedBuddyItems(selectedBuddys);
	if (selectedBuddys.size()>0)
	{
		std::vector<const IGTBuddyUser *>::iterator buddyIterator =selectedBuddys.begin();
		const IGTBuddyUser *pUser = *buddyIterator;
		ASSERT(pUser != NULL);
        CPoint pt(0, 0);
		GetCursorPos(&pt);
//		GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(pUser->GetUserID(), pt, m_pFrame->GetSafeHwnd());
	}
}

void CBuddyTreeCtrl::MakeChatDlg(BUDDY_SENDACTIONType followAction) 
{
	std::vector<const IGTBuddyUser *> selectedBuddyItems;
	const int onlineCount  = m_favoriteController->GetSelectedOnlineFavorites(selectedBuddyItems);
	if (onlineCount > 0)
	{
		GET_APP()->m_pChatDialogManager->CreateBuddyChat(selectedBuddyItems,followAction);
	}	
}

void CBuddyTreeCtrl::MakeSendNoteDlg() 
{
	std::vector<const IGTBuddyUser* > buddyVector;
	m_favoriteController->GetSelectedBuddyItems(buddyVector);
	GET_APP()->m_pSendNoteManager->CreateBuddyListNote(buddyVector);
}

void CBuddyTreeCtrl::MakeSendSMSDlg()
{
	std::vector<const IGTBuddyUser* > buddyVector;
	m_favoriteController->GetSelectedBuddyItems(buddyVector);
	GET_APP()->m_pSMSDialogManager->CreateBuddyLIstSMS(buddyVector);
}

void CBuddyTreeCtrl::CallCompanyPhone(Node* pNode)
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);

	//const IGTBuddyUser *pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
	CString usrID = pNode->data().value;
	const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
	if( pUser != NULL )
	{
		const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo( pUser->GetUserID() );

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if (pManager)
			pManager->MakeCall(*pData, pData->strIncoTel.c_str());
	}
}

void CBuddyTreeCtrl::CallCellPhone(Node* pNode)
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);

	//const IGTBuddyUser *pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
	CString usrID = pNode->data().value;
	const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
	if( pUser != NULL )
	{
		const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo( pUser->GetUserID() );

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if (pManager)
			pManager->MakeCall(*pData, pData->strCellPhone.c_str());
	}
}

void CBuddyTreeCtrl::CallIPPhone(Node* pNode)
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);

	//const IGTBuddyUser *pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
	CString usrID = pNode->data().value;
	const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
	if( pUser != NULL )
	{
		const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo( pUser->GetUserID() );

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if (pManager)
			pManager->MakeCall(*pData, pData->strIPPhone.c_str());
	}
}

void CBuddyTreeCtrl::CallTransfer( Node* pNode )
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);

	//const IGTBuddyUser *pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
	CString usrID = pNode->data().value;
	const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
	if( pUser != NULL )
	{

		TRACE(TEXT("Tranfer Call  ID= %s\n"), g_pMessengerActor->GetUserID() );
		const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo( pUser->GetUserID() );

		if (pUser->GetUserID() == g_pMessengerActor->GetUserID() )
		{
			NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING588));
		}
		else
			g_pMessengerActor->RequestCallTransfer( g_pMessengerActor->GetUserID(), pUser->GetUserID() );
	}
}
void CBuddyTreeCtrl::CallConfer( Node* pNode )
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);
	//const IGTBuddyUser *pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
	CString usrID = pNode->data().value;
	const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
	if( pUser != NULL )
	{

		TRACE(TEXT("Confer Call  ID= %s\n"), g_pMessengerActor->GetUserID() );
		const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo( pUser->GetUserID() );

		if (pUser->GetUserID() == g_pMessengerActor->GetUserID() )
		{
			NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING588));
		}
		else
		{
			const NE_MEMBER_DATA* pMemberData = g_pMessengerActor->GetEmployeeInfo(pUser->GetUserID());
			if( pMemberData != NULL )
			{
				CString strPhoneNum = pMemberData->strExtesion.c_str();
				g_pMessengerActor->RequestConferenceCall( g_pMessengerActor->GetUserID(), strPhoneNum );
			}
			else
				NMessageBox(CWnd::FromHandle(m_pFrame->m_hWnd), LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_SERVERINTERNALERROR), _T("Ntalk Biz"), MB_OK);
		}
	}
}

void CBuddyTreeCtrl::CallExtensionPhone(Node* pNode)
{
	//TRACE("%s %d\n", __FUNCTION__, __LINE__);

	//const IGTBuddyUser *pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
	CString usrID = pNode->data().value;
	const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 
	if( pUser != NULL )
	{
		const NE_MEMBER_DATA* pData = g_pMessengerActor->GetEmployeeInfo( pUser->GetUserID() );

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if (pManager)
			pManager->MakeCall(*pData, pData->strExtesion.c_str());
	}
}

void CBuddyTreeCtrl::MakeChatHistoryDlg()
{
	GET_MESSENGER_DLG()->PostMessage(WM_COMMAND, ID_FAVORITE_USER_CHAT_HISTORY, 0);
}

void CBuddyTreeCtrl::MenuCmd( int nCmdID, Node* pNode ) 
{
	switch(nCmdID)
	{
	case ID_FAVORITE_USER_INFO: // :ȭ
		MakeProfileDlg();
		break;
	case ID_FAVORITE_USER_CHAT: // :ȭϱ
		MakeChatDlg();
		break;
	case ID_FAVORITE_USER_SENDFILE:
		MakeChatDlg(SENDACTION_FILE );
		break;
	case ID_FAVORITE_USER_MEMO: // :		
		MakeSendNoteDlg();
		//MakeSendSMSDlg();
		break;
	case ID_FAVORITE_USER_SMS:	// :SMS 
		MakeSendSMSDlg();
		break;
	case ID_FAVORITE_USER_COMPANY_PHONE: //ȸȭ
		CallCompanyPhone(pNode);
		break;
	case ID_FAVORITE_USER_CELL_PHONE:	// ڵ
		CallCellPhone(pNode);
		break;
	case ID_FAVORITE_USER_IP_PHONE:		// IP ȭ(޴ )
		CallIPPhone(pNode);
		break;
	case ID_FAVORITE_USER_CONFER_CALL:
		CallConfer(pNode);
		break;
	case ID_FAVORITE_USER_TRANSFER_CALL:
		CallTransfer(pNode);
		break;
	case ID_FAVORITE_USER_EXTENTION_TEL:	// ȣ
		CallExtensionPhone(pNode);
		break;
	case ID_FAVORITE_USER_DEL: // :ȭ 
		{
			std::vector<const IGTBuddyUser* > buddyVector;
			m_favoriteController->GetSelectedBuddyItems(buddyVector, false);
			m_favoriteController->RequestDeleteBuddy(buddyVector);
		}
		break;
	case ID_FAVORITE_USER_CHAT_HISTORY:		//  ȭ 
		MakeChatHistoryDlg();
		break;
	case ID_FAVORITE_GROUP_CHAT: // ׷:ȭϱ
		MakeChatDlg();
		break;
	case ID_FAVORITE_GROUP_SENDFILE: // ׷:ȭϱ
		MakeChatDlg(SENDACTION_FILE );
		break;
	case ID_FAVORITE_GROUP_MEMO: // ׷:
		MakeSendNoteDlg();
		break;
	case ID_FAVORITE_GROUP_SMS:	// :SMS 
		MakeSendSMSDlg();
		break;
	case ID_FAVORITE_GROUP_MAKE: // ׷:׷츸
		m_favoriteController->RequestAddGroup();
		break;
	case ID_FAVORITE_GROUP_RENAME: // ׷:׷̸ٲٱ
		{
            ASSERT(pNode);
            if (pNode)  //413(lint)
            {
                const IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
                if (NULL != pGroup)
                {
                    //m_favoriteController->EditLableOn(pGroup);
                    SetNodeEdit( pGroup->GetID());
                }
            }
		}
		break;
	case ID_FAVORITE_GROUP_DEL: // ׷:׷
		{
            ASSERT(pNode);
            if (pNode)  //413(lint)
            {
                const IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
                m_favoriteController->RequestDeleteGroup(pGroup);
            }
		}
		break;
	/*case ID_FAVORITE_GROUP_IMPORT:
		{
			m_favoriteController->ImportGroup();
		}
		break;
	case ID_FAVORITE_GROUP_EXPORT:
		{
			GT_MY_USER_DATA myUserData;
			g_pMessengerActor->GetMyUserInfo(myUserData);
			CString strDefaultName = myUserData.sMyPage.strUserName;

			CTime time(CTime::GetCurrentTime());
			GetLocaleTime(&time);
			strDefaultName += time.FormatGmt(_T("%Y%m%d"));

			if (pNode)
			{
				const IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
				if (NULL != pGroup)
				{
					std::vector<const IGTBuddyGroup* > groupVector;
					m_favoriteController->GetSelectedGroupItems(groupVector);
					m_favoriteController->ExportGroup(groupVector, strDefaultName);
				}
			}
			else	// ü ׷ 
			{
				std::vector<const IGTBuddyGroup* > groupVector;
				m_favoriteController->GetAllGroupItems(groupVector);

				m_favoriteController->ExportGroup(groupVector, strDefaultName);
			}
		}
		break;*/
	default:
		{	
			if(nCmdID >= ((int)ID_COPYGROUPLIST_START) && nCmdID < ((int)ID_COPYGROUPLIST_END))
			{
				MenuCopyBuddy(nCmdID , ID_COPYGROUPLIST_START);
			}
			else if(nCmdID >= ((int)ID_MOVEGROUPLIST_START) && nCmdID < ((int)ID_MOVEGROUPLIST_END))
			{
				MenuMoveBuddy(nCmdID,ID_MOVEGROUPLIST_START);
			}
		}
		break;
	}

}

void CBuddyTreeCtrl::MenuMoveBuddy( UINT nCmdID, int nMenuStartID )
{
	std::vector<Node*> vecSelectedItem;
	vecSelectedItem = m_favoriteController->GetSelectedBuddyItems();

	std::vector<int> vecBuddyID;
	//std::vector<int> vecDelBuddyID;
	std::vector<int> groupIDList;
	groupIDList = m_favoriteController->GetTargetGroupIdList(0);
	int nIndex = nCmdID - nMenuStartID;
	int nTargetID = groupIDList[nIndex];

	for(std::vector<Node*>::iterator itr = vecSelectedItem.begin(); itr != vecSelectedItem.end(); itr++)
	{
		Node* pNode;
		pNode = *itr;

		// ó?
		//const IGTBuddyUser* pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
		CString usrID = pNode->data().value;
		Node* pGroupNode = pNode->parent();
		if(pGroupNode == NULL && !IsGroup(pGroupNode)) continue;

		const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pGroupNode->GetNodeUserData();
		if(pGroup == NULL) continue;

		const IGTBuddyUser *pUser = g_pMessengerActor->GetBuddyInfo(usrID, pGroup->GetID());
		ASSERT(pUser != NULL);
		if (NULL != pUser)
		{
			bool IsExistGroupBuddy;
			IsExistGroupBuddy =m_favoriteController->IsExistGroup(pUser->GetUserID(),nTargetID);
			if (!IsExistGroupBuddy)
			{
				vecBuddyID.push_back(pUser->GetID());
			}

		}
	}

	if (false == m_favoriteController->RequestMoveBuddy(vecBuddyID, nTargetID/*,vecDelBuddyID*/))
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
	}
}

void CBuddyTreeCtrl::MenuCopyBuddy( UINT nCmdID, int nMenuStartID ) 
{
	std::vector<Node*> vecSelectedItem;
	vecSelectedItem = m_favoriteController->GetSelectedBuddyItems();
	std::vector<wstring> vecBuddyID;
	std::vector<int> vecDelBuddyID;
	std::vector<int> groupIDList;
	groupIDList = m_favoriteController->GetTargetGroupIdList(0);
	int nIndex = nCmdID - nMenuStartID;
	int nTargetID = groupIDList[nIndex];

	for(std::vector<Node*>::iterator itr = vecSelectedItem.begin(); itr != vecSelectedItem.end(); itr++)
	{
		Node* pNode;
		pNode = *itr;

		// ó?
		//const IGTBuddyUser* pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
		CString usrID = pNode->data().value;
		
		vecBuddyID.push_back(usrID.GetString());
		
	}
	m_favoriteController->RequestAddBuddy(nTargetID, vecBuddyID);
}

/*
void CBuddyTreeCtrl::MenuSortGroup( std::vector<const IGTBuddyGroup*> &vecGroupInfo)
{	
	if (false == m_favoriteController->RequestSortGroup(vecGroupInfo))
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
	}

}*/

//void CBuddyTreeCtrl::MenuMoveBuddy( int nTargetID )
//{
//	std::vector<Node*> vecSelectedItem;
//	vecSelectedItem = m_favoriteController->GetSelectedBuddyItems();
//
//	std::vector<int> vecBuddyID;
///*
//	std::vector<int> groupIDList;
//	groupIDList = m_favoriteController->GetTargetGroupIdList(0);*/
//    //const IGTBuddyUser* pUser = NULL;
//	for(std::vector<Node*>::iterator itr = vecSelectedItem.begin(); itr != vecSelectedItem.end(); itr++)
//	{
//		Node* pNode = *itr;
//
//		// ó?
//		//pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
//		CString usrID = pNode->data().value;
//		Node* pGroupNode = pNode->parent();
//		if(pGroupNode == NULL && !IsGroup(pGroupNode)) continue;
//
//		const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pGroupNode->GetNodeUserData();
//		if(pGroup == NULL) continue;
//
//		const IGTBuddyUser *pUser = g_pMessengerActor->GetBuddyInfo(usrID, pGroup->GetID());
//		ASSERT(pUser != NULL);
//		if (NULL != pUser)
//		{
//			bool IsExistGroupBuddy;
//			IsExistGroupBuddy =m_favoriteController->IsExistGroup(pUser->GetUserID(),nTargetID);
//			if (!IsExistGroupBuddy)
//			{
//				vecBuddyID.push_back(pUser->GetID());
//			}
//
//		}
//	}
//
//	if (false == m_favoriteController->RequestMoveBuddy(vecBuddyID, nTargetID))
//	{
//		GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
//	}
//}
//
//void CBuddyTreeCtrl::MenuCopyBuddy( int nTargetID ) 
//{
//	std::vector<Node*> vecSelectedItem;
//	vecSelectedItem = m_favoriteController->GetSelectedBuddyItems();
//	int selectedGroupId = -1;
//
//	vector<Node*> vecSelectItems = GetSelectedItems();
//	Node* pNodeParent = vecSelectItems[0]->parent();
//
//	if(IsGroup(pNodeParent))
//	{
//		IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNodeParent->GetNodeUserData();
//        if (pGroup)
//        {
//            selectedGroupId = pGroup->GetID();
//        }
//	}
//
//	std::vector<wstring> vecBuddyID;
//	std::vector<int> vecDelBuddyID;
//	std::vector<int> groupIDList;
//	groupIDList = m_favoriteController->GetTargetGroupIdList(0);
//	 const IGTBuddyUser* pUser = NULL;
//
//	for(std::vector<Node*>::iterator itr = vecSelectedItem.begin(); itr != vecSelectedItem.end(); itr++)
//	{
//		Node* pNode;
//		pNode = *itr;
//
//		// pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
//		CString usrID = pNode->data().value;
//		vecBuddyID.push_back(usrID.GetString());
//		/*Node* pNode;
//		pNode = *itr;
//
//		pUser = (IGTBuddyUser*)pNode->GetNodeUserData();
//		ASSERT(pUser != NULL);
//		if (NULL != pUser)
//		{
//			bool IsExistGroupBuddy;
//			IsExistGroupBuddy =m_favoriteController->IsExistGroup(pUser->GetUserID(),nTargetID);
//			if (!IsExistGroupBuddy)
//			{
//				vecBuddyID.push_back(pUser->GetID());
//			}
//
//		}*/
//	}
//	m_favoriteController->RequestAddBuddy(nTargetID, vecBuddyID);
//}


//BOOL IsFindByID_UserNodeVector(std::vector<Node*>& vecSelectedBuddyUser, LPCTSTR strID)
//{
//	CString strFindID = strID;
//	for (size_t j = 0; j < vecSelectedBuddyUser.size(); j++)
//	{
//		CString strUserID = ((IGTBuddyUser*)(vecSelectedBuddyUser[j]->GetNodeUserData()))->GetUserID();
//		if (strUserID.CompareNoCase(strFindID) == 0)
//		{
//			return TRUE;
//		}
//	}
//	return FALSE;
//}


void CBuddyTreeCtrl::HandleDragBuddy( Node* pNodeTarget, vector<wstring> vecUserID )
{
	if(pNodeTarget == NULL || vecUserID.size() == 0)
	{
		return;
	}

	int nGroupId = 0;
	if(IsGroup(pNodeTarget))
	{
		const IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNodeTarget->GetNodeUserData();
		nGroupId = pGroup->GetID();
	}
	else
	{
		//const IGTBuddyUser* pUser = (IGTBuddyUser*)pNodeTarget->GetNodeUserData();
		CString usrID = pNodeTarget->data().value;
		Node* pGroupNode = pNodeTarget->parent();
		if(pGroupNode == NULL && !IsGroup(pGroupNode)) return;

		const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pGroupNode->GetNodeUserData();
		if(pGroup == NULL) return;

		const IGTBuddyUser *pUser = g_pMessengerActor->GetBuddyInfo(usrID, pGroup->GetID());
		ASSERT(pUser != NULL); 
		nGroupId = pUser->GetGroupID();		
	}

	m_favoriteController->RequestAddBuddy(nGroupId, vecUserID);

}


void CBuddyTreeCtrl::HandleDragDrop(Node* hotNode)
{
    if (!hotNode)
    {
        return;
    }
    int nTargetID = 0;

    if (IsGroup(hotNode))
    {
        IGTBuddyGroup* pGroup = (IGTBuddyGroup*)hotNode->GetNodeUserData();
        if (pGroup)
        {
            nTargetID = pGroup->GetID();
        }
    }
    else if( hotNode->parent() != NULL && !hotNode->has_children()){
        IGTBuddyGroup* pGroup = (IGTBuddyGroup*)hotNode->parent()->GetNodeUserData();
        if (pGroup)
        {
            nTargetID = pGroup->GetID();
        }
    }
    if (nTargetID == 0)
    {
        return;
    }    

    //std::vector<Node*> vecSelectedItem;
    //vecSelectedItem = m_favoriteController->GetSelectedBuddyItems(); //Get selected buddy nodes,group nodes NOT included;
    //std::vector<const IGTBuddyGroup*> vecSelectedGroup;
    // m_favoriteController->GetSelectedGroupItems(vecSelectedGroup); // Get selected groups nodes;

    std::vector<Node *> vecSelectedItem;
    std::vector<IGTBuddyGroup*> vecSelectedGroup;
    std::vector<Node*> vecAllSelectedItem = m_favoriteController->GetSelectedItems();

    for (size_t i = 0; i < vecAllSelectedItem.size(); i++)
    {
        Node* pNode = vecAllSelectedItem[i];
        if (pNode->folder() && !pNode->IsRoot())
        {
            IGTBuddyGroup* pGroup = (IGTBuddyGroup*)pNode->GetNodeUserData();
            vecSelectedGroup.push_back(pGroup);
        }
        else
        {
            CString strUserID = pNode->data().value;
            BOOL bFind = FALSE;
            for (size_t j = 0; j < vecSelectedItem.size(); j++)
            {

                CString strCurID = vecSelectedItem[j]->data().value;
                if (strUserID.CompareNoCase(strCurID) == 0)
                {
                    bFind = TRUE;
                    break;
                }
            }
            if (!bFind)
            {
                vecSelectedItem.push_back(pNode);
            }
        }
    }

    std::vector<wstring> vecBuddyIDFromRecentContact;
    std::vector<int> vecBuddyID;

    for(std::vector<Node*>::iterator itr = vecSelectedItem.begin(); itr != vecSelectedItem.end(); itr++)
    {
        Node* buddyNode = *itr;
        // IGTBuddyUser* pUser = (IGTBuddyUser*)buddyNode->GetNodeUserData();
        CString usrID = buddyNode->data().value;
        Node* pGroupNode = buddyNode->parent();
        if(pGroupNode == NULL && !IsGroup(pGroupNode)) continue;

        const IGTBuddyGroup *pGroup = (const IGTBuddyGroup *)pGroupNode->GetNodeUserData();
        if(pGroup == NULL) continue;

        const IGTBuddyUser *pUser = g_pMessengerActor->GetBuddyInfo(usrID, pGroup->GetID());
        if(pUser == NULL)
        {
            pUser = g_pMessengerActor->GetBuddyInfoFromPersist(usrID);
        }
        if (NULL != pUser)
        {
            bool IsExistGroupBuddy;
            IsExistGroupBuddy =m_favoriteController->IsExistGroup(pUser->GetUserID(),nTargetID);
            if (!IsExistGroupBuddy)
            {
                if(IsFromRecentContact(buddyNode))
                {
                    vecBuddyIDFromRecentContact.push_back(pUser->GetUserID());
                }
                else
                {
                    vecBuddyID.push_back(pUser->GetID());
                }

            }	
        }
    }

    if (vecSelectedItem.size() > 0)  //ѡеbuddyΪգôѡеgroupǷΪգִbuddyadd/buddymove
    {
        if (vecBuddyID.size() > 0)
        {
            if(false == m_favoriteController->RequestMoveBuddy(vecBuddyID, nTargetID))
            {
                //do nothing
                //C4390: ';' : empty controlled statement found; is this the intent?
            }
        }
        if(vecBuddyIDFromRecentContact.size() > 0)
        {
            m_favoriteController->RequestAddBuddy(nTargetID, vecBuddyIDFromRecentContact);		 
        }	
        if (vecBuddyID.empty() && vecBuddyIDFromRecentContact.empty()) //ѡеΪգǿĽڵ㲻ڣ˵ظ
        {
            GET_APP()->m_pMessageBoxManager->CreateMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
        }
    }
    else if (vecSelectedItem.empty() && vecSelectedGroup.size() > 0) ////ѡеbuddyΪgroupΪգôִgroup
    {
        const IGTBuddyGroup* pGroup = vecSelectedGroup[0];
        Node* DragNode = NodeDataConvertToNode(pGroup);
        m_friendDragHelper->DoGroupDragSort(hotNode,DragNode);
    }
}

Node* CBuddyTreeCtrl::NodeDataConvertToNode(const IGTBuddyGroup* pBuddyGroup){
   
	std::map<int, Node*>::iterator it;

	for (it = m_mapGroups.begin(); it != m_mapGroups.end(); it++)
	{
		Node* pGroupNode = it->second;
		const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)pGroupNode->GetNodeUserData();

		if (NULL != pGroup)
		{
			if (pGroup->GetID() == pBuddyGroup->GetID() &&
				(_tcsicmp(pGroup->GetName(), pBuddyGroup->GetName()) == 0))
			{
               return pGroupNode;
       
			}
		}
	}
   return NULL;

}


Node* CBuddyTreeCtrl::GetGroupByID(int nGroupid)
{
	return m_mapGroups[nGroupid];
}

void CBuddyTreeCtrl::ExPandGroup()
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));

	std::map<int, Node*>::iterator it;

	for (it = m_mapGroups.begin(); it != m_mapGroups.end(); it++)
	{
		Node* pGroupNode = it->second;
		const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)pGroupNode->GetNodeUserData();

		if (NULL != pGroup)
		{
			std::map<int, int>::const_iterator itr = GET_CONFIG()->m_mapExpandBuddyGroup.find(pGroup->GetID());
			if (itr != GET_CONFIG()->m_mapExpandBuddyGroup.end())
			{
				pFriendsList->SetChildVisible(pGroupNode, true);
			}
		}
	}
}

void CBuddyTreeCtrl::SetNodeEdit(int nGroupID)
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	std::map<int, Node*>::iterator it = m_mapGroups.find(nGroupID);
	if(it != m_mapGroups.end())
	{
		Node* pGroupNode = it->second;
		pFriendsList->SetNodeEditable(pGroupNode,true);
	}
}

void CBuddyTreeCtrl::PageDown()
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	pFriendsList->EndDown();
}

void CBuddyTreeCtrl::UpdataAllBuddyDisplayNames(int nDisplaType)
{
	std::map<int, Node*>::iterator it;

	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));

	for (it = m_mapGroups.begin(); it != m_mapGroups.end(); it++)
	{
		Node* pGroupNode = it->second;
		const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)pGroupNode->GetNodeUserData();

		if (NULL != pGroup)
		{
			for(int j = 0; j < pGroupNode->num_children(); j++)
			{
				Node* hItem = pGroupNode->child(j);
				//const IGTBuddyUser* pUser = (IGTBuddyUser*)hItem->GetNodeUserData();
				CString usrID = hItem->data().value;
				const IGTBuddyUser* pUser = g_pMessengerActor->GetAvailbeBuddyInfo(usrID); 

				if(pUser)
				{				
					CDuiString strUserName = pUser->GetName();
					CDuiString strUserSign = pUser->GetTalkName();

					CTextUI* realName = static_cast<CTextUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, kNickNameControlName));
					CTextUI* sign_center = static_cast<CTextUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, _T("sign")));

					bool bShowRealName = (0 == nDisplaType || 1 ==nDisplaType) && (!strUserName.IsEmpty());
					realName->SetText(strUserName);
					realName->SetVisible(true);

					bool bShowSign = (0 == nDisplaType || 2 ==nDisplaType) && (!strUserSign.IsEmpty());

					
					sign_center->SetText(strUserSign);
					sign_center->SetVisible(true);
				}
			}
		}
	}
}

void CBuddyTreeCtrl::UpdateStaus(LPCWSTR strUserId, const IGTBuddyUser *pUser, const NE_MEMBER_DATA* data)
{
	std::map<int, Node*>::iterator it;

	if (!data)
	{
		ASSERT(FALSE);
		return; //lint !e527
	}
	for (it = m_mapGroups.begin(); it != m_mapGroups.end(); it++)
	{
		Node* pGroupNode = it->second;
		const IGTBuddyGroup *pGroup = (IGTBuddyGroup*)pGroupNode->GetNodeUserData();

		if (NULL != pGroup)
		{
			for(int j = 0; j < pGroupNode->num_children(); j++)
			{
				Node* hItem = pGroupNode->child(j);
				//const IGTBuddyUser* pp = (IGTBuddyUser*)hItem->GetNodeUserData();

				CString usrIDNode = hItem->data().value;
				const IGTBuddyUser* pInnerUser = (IGTBuddyUser*)g_pMessengerActor->GetBuddyInfo(usrIDNode);
				if (NULL == pInnerUser)
				{
					pInnerUser = (IGTBuddyUser*)g_pMessengerActor->GetBuddyInfoFromPersist(usrIDNode);
				}
				CDuiString userName = strUserId;
				if(pInnerUser && userName == pInnerUser->GetUserID())
				{
					const NE_MEMBER_DATA *pInnerData = g_pMessengerActor->GetEmployeeInfo(strUserId);
					hItem->SetMemberData(pInnerData);
					GTUserStatusType ust = pInnerUser->GetStatus();

					bool mobile = ( ust & ustMOBILE );
					CDuiString status  = m_pFrame->GetImageFromStatus( ust, TRUE,!pInnerData->strWorkStatus.empty());

					CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));

					CHorizontalLayoutUI* pMobileControl = static_cast<CHorizontalLayoutUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, _T("mobile_online")));
					if (pMobileControl != NULL)
					{
						pMobileControl->SetVisible(false);
					}
					
					CDuiString strUserSign = _T("");
                    if(pInnerData){
						strUserSign = pInnerData->strNickName.c_str();
                    }


					int nDisplaType = GET_CONFIG()->GetNameDisplayType();

					bool bShowSign = (0 == nDisplaType || 2 ==nDisplaType) && (!strUserSign.IsEmpty());

					CTextUI* sign_center = static_cast<CTextUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, _T("sign")));

					sign_center->SetText(strUserSign);
					sign_center->SetToolTip(strUserSign);
					sign_center->SetVisible(true);
					sign_center->NeedParentUpdate();

					CButtonUI* pBtnIPT = static_cast<CButtonUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, _T("iptbtn")));
					NTIPTStatusType iptStatus = pInnerUser->GetIPTStatus();
					BOOL bIPT = GET_APP()->IsAvailableIPT();

					TCHAR szBufIPT[MAX_PATH] = {0};
					if(pBtnIPT != NULL)
					{
						if(bIPT == TRUE)
						{
							NTIPTStatusType stStatus = pInnerUser->GetIPTStatus();

							CDuiString strStatus = GetIPTPresenceTip(stStatus);
							pBtnIPT->SetToolTip(strStatus.GetData());

							pBtnIPT->SetVisible(true);
							CString imgPath = GET_APP()->GetBuddyIPTPresenceImageFilePath(iptStatus);
							pBtnIPT->SetBkImage(imgPath);
							if(imgPath.IsEmpty())
								pBtnIPT->SetVisible(false);
						}
						else
						{
							pBtnIPT->SetVisible(false);
						}
					}

					CDuiString strTooltip;

					const IGTBuddyUser * pBuddyUser = g_pMessengerActor->GetBuddyInfo(strUserId);
					if(pBuddyUser == NULL)
					{
						pBuddyUser = g_pMessengerActor->GetBuddyInfoFromPersist(strUserId);
					}
					if (pBuddyUser)
					{
						CDuiString strStatus;
						GTUserStatusType stStatus = pBuddyUser->GetStatus();
						//const NE_MEMBER_DATA *pInnerData = g_pMessengerActor->GetEmployeeInfo(strUserId.c_str());
						strStatus = GetPresenceTip(stStatus);
						CDuiString fmt = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_13);
						strTooltip.Format(fmt,pInnerData->strName.c_str(),strStatus.GetData(),pInnerData->strEmail.c_str());
// 						CDuiString strStatus = GetPresenceTip(stStatus);
// 						CDuiString fmt = LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_13);
// 						strTooltip.Format(fmt,pInnerData->strName.c_str(),strStatus.GetData(),pInnerData->strEmail.c_str());
					}
				   
					CLabelUI* pLog = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, _T("logo")));
					CLabelUI* pNickName = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, kNickNameControlName));
					CLabelUI* pStatusControl = static_cast<CLabelUI*>(pFriendsList->paint_manager_.FindSubControlByName(hItem->data().list_elment_, _T("description")));
					if (pStatusControl != NULL)
					{
						TCHAR szBuf[MAX_PATH] = {0};
						_stprintf_s(szBuf, MAX_PATH - 1, _T("%s"), status);
						pStatusControl->SetBkImage(szBuf);
					}
// 
					if (pLog && pNickName && pStatusControl)
					{
						pLog->SetToolTip(strTooltip);
						pNickName->SetToolTip(strTooltip);


						if (ustOFFLINE == pBuddyUser->GetStatus() && GET_CONFIG()->EnableFunction(_T("UI_01")) && !pInnerData->strWorkStatus.empty())
						{
							strTooltip = pInnerData->strWorkStatus.c_str();
							strTooltip.Replace(_T(":"),_T("\n"));
						}
						pStatusControl->SetToolTip(strTooltip);
					}

					hItem->data().text_ = pInnerUser->GetDisplayName();

					//pFriendsList->SetChildVisible(hItem,hItem->data().child_visible_);;
					break;
				}
			}

			if(pGroup->GetID() == RECENT_CONTACT_GROUP_ID)
			{
				m_favoriteController->UpdateRecentContactGroupName();
			}
			else
			{
				m_favoriteController->UpdateGroupName(pGroup);
				m_favoriteController->ResortBuddyInGroup(pGroup->GetID());
			}
		}
	}
}




Node* CBuddyTreeCtrl::HitTest(CPoint pt)
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	int nCount = pFriendsList->GetCount();
 
	Node* pNode = NULL;
	for(int i = 0; i < nCount; i++)
	{
		CControlUI* pItem = pFriendsList->GetItemAt(i);
		RECT rc = pItem->GetPos();
		if(pItem->IsVisible() && PtInRect(&rc ,pt))
		{
			pNode = (Node*)pItem->GetTag();
			
			return pNode;
		}
	}


	return NULL;
}

CBuddyTreeCtrl::CBuddyTreeCtrl( MainFrame* pFrame )
{
	m_pFrame = pFrame; 	
    m_favoriteController = NULL;
	m_friendDragHelper = new CFriendListDragHelper;
	m_friendDragHelper->SetFriendList(this);
}

BOOL CBuddyTreeCtrl::IsFromRecentContact(Node* NodeDrop)
{
	if(!IsGroup(NodeDrop))
	{
		NodeDrop = NodeDrop->parent();
	}
	if(!IsGroup(NodeDrop))
	{
		return FALSE;
	}

	IGTBuddyGroup* pGroup = (IGTBuddyGroup*)NodeDrop->GetNodeUserData();
	if(pGroup && pGroup->GetID() == RECENT_CONTACT_GROUP_ID)
	{
		return TRUE;
	}

	return FALSE;
}

void CBuddyTreeCtrl::DeleteAllItem()
{
	CFriendsUI* pFriendsList = static_cast<CFriendsUI*>(m_pFrame->m_PaintManager.FindControl(kFriendsListControlName));
	if (pFriendsList != NULL)
	{
		if (pFriendsList->GetCount() > 0)
		{
			pFriendsList->RemoveAll();
		}
		m_mapGroups.clear();
	}
}
